/* rulelist.cc
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <glade/glade-xml.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include "rulelist.h"
#include "main.h"
#include "misc.h"
#include "gui.h"
#include "licon.xpm"

static gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{ ((RuleList*)data)->hide(); return (TRUE); }
static void close_cb(GtkWidget *w, gpointer data)
{ ((RuleList*)data)->hide(); }

RuleList::RuleList(Main *m)
{
	GladeXML *gxml;

	main = m;

	gchar *fname = user_file("rules.glade");
	gxml = glade_xml_new (fname, "rulelist");
	if (!gxml)
	{
		g_warning("Failed to load file rules.glade");
		return;
	}

	window = glade_xml_get_widget (gxml, "rulelist");
	clist1 = glade_xml_get_widget (gxml, "clist1");
	button20 = glade_xml_get_widget (gxml, "button20");
	button21 = glade_xml_get_widget (gxml, "button21");
	button22 = glade_xml_get_widget (gxml, "button22");
	button23 = glade_xml_get_widget (gxml, "button23");
	gtk_object_unref (GTK_OBJECT (gxml));
	g_free(fname);

	gtk_widget_set_usize (window, 420, 280);
	gtk_widget_realize (window);
	window_icon(window, licon_xpm);
	gdk_window_set_icon_name(window->window, "Rule List");
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		GTK_SIGNAL_FUNC(delete_event), this);
	gtk_signal_connect(GTK_OBJECT(window), "destroy",
		GTK_SIGNAL_FUNC(delete_event), this);

	gtk_signal_connect (GTK_OBJECT (button20), "pressed",
		GTK_SIGNAL_FUNC (close_cb), this);
}

RuleList::~RuleList()
{
}

void RuleList::show()
{
	gtk_widget_show(window);
	gdk_window_raise(window->window);
}

void RuleList::hide()
{
	gtk_widget_hide(window);
}

void RuleList::update()
{
}

void RuleList::add(char *str)
{
}

