/* searchsidebar.cc
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>
#include "main.h"
#include "data.h"
#include "searchsidebar.h"
#include "session.h"
#include "gui.h"
#include "ssubnet.xpm"
//#include "srouter.xpm"

static void on_Apply_activate(GtkWidget *w, gpointer data)
{ ((SearchSideBar*)data)->apply(); }

static void search_list_cb(GtkWidget *clist, gint row, gint column, GdkEventButton *event, gpointer data)
{
/*
	SearchView *m = (SearchView*) data;
	Router *r;
	Machine *mc;
	gchar *text;

	m->ptr = gtk_clist_get_row_data(GTK_CLIST (clist), row);
	gtk_clist_get_text(GTK_CLIST(clist), row, 0, &text);
	m->type = 0;
	if (strcmp("Subnet", text)==0)
	{
		m->type = 1;
		m->main->subnet->current_subnet = (Subnet*) m->ptr;
		m->main->subnet->tags();
	}else
	if (strcmp("Device", text)==0)
	{
		m->type = 2;
		r = (Router*) m->ptr;
		r->selected = 1;
		m->main->monitor->draw();
	}else
	if (strcmp("Machine", text)==0)
	{
		m->type = 3;
		mc = (Machine*) m->ptr;
		mc->network->selected = 1;
		m->main->monitor->draw();
	}

	m->expose_search();
*/
}

static void search_list_cb2(GtkWidget *clist, gint row, gint column, GdkEventButton *event, gpointer data)
{
/*
	SearchView *m = (SearchView*) data;
	m->ptr = NULL;
	m->type = 0;
	m->main->files->clear_tags();
	m->main->monitor->draw();
	m->expose_search();
*/
}

SearchSideBar::SearchSideBar(Main *m)
{
	GtkWidget *label162;
	GtkWidget *scrolledwindow31;
	GtkWidget *hbox90;
	GtkWidget *button94;

	main = m;
	ptr = NULL;
	type = 0;
	current_sort = 0;
	strcpy(search_string, "");

	vbox12 = gtk_vbox_new (FALSE, 2);
  gtk_widget_show (vbox12);
  gtk_container_set_border_width (GTK_CONTAINER (vbox12), 2);

  label162 = gtk_label_new ("Keyword Search");
  gtk_widget_show (label162);
  gtk_box_pack_start (GTK_BOX (vbox12), label162, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label162), 0, 0.5);

  hbox90 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox90);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox90, FALSE, FALSE, 0);

  entry35 = gtk_entry_new ();
  gtk_widget_show (entry35);
  gtk_box_pack_start (GTK_BOX (hbox90), entry35, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(entry35), "activate",
		GTK_SIGNAL_FUNC(on_Apply_activate), this);

  button94 = gtk_button_new_with_label ("Go");
  gtk_widget_show (button94);
  gtk_box_pack_start (GTK_BOX (hbox90), button94, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (button94), "clicked",
		GTK_SIGNAL_FUNC (on_Apply_activate), this);

  scrolledwindow31 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow31);
  gtk_box_pack_start (GTK_BOX (vbox12), scrolledwindow31, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow31),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist28 = gtk_clist_new (2);
  gtk_widget_show (clist28);
  gtk_container_add (GTK_CONTAINER (scrolledwindow31), clist28);
  gtk_clist_column_titles_hide (GTK_CLIST (clist28));
	gtk_signal_connect(GTK_OBJECT(clist28), "select_row",
		GTK_SIGNAL_FUNC(search_list_cb), this);
	gtk_signal_connect(GTK_OBJECT(clist28), "unselect_row",
		GTK_SIGNAL_FUNC(search_list_cb2), this);

	gtk_clist_set_column_visibility (GTK_CLIST(clist28), 1, FALSE);
	gtk_clist_set_column_width (GTK_CLIST(clist28), 0, 20);
}

SearchSideBar::~SearchSideBar()
{
}

void SearchSideBar::apply()
{
	Link *ln;
	Subnet *sn;
	gchar *data[1];
	char buf[256];
	int row;

	if (main->session->data==NULL) return;

	gchar *txt = gtk_entry_get_text(GTK_ENTRY(entry35));
	strcpy(search_string, txt);
	ptr = NULL;
	type = 0;

	row=0;
	gtk_clist_freeze(GTK_CLIST(clist28));
	gtk_clist_clear(GTK_CLIST(clist28));
	for (ln=main->session->data->subnets.get_head(); ln!=NULL; ln=ln->next)
	{
		sn = (Subnet*) ln->item;
		sn->match(search_string);
		if (sn->find!='0')
		{
			sprintf(buf, "%s/%d", sn->ip.getstring(), sn->mask);
			data[0] = strdup("");
			gtk_clist_append(GTK_CLIST(clist28), data);
			delete data[0];
			clist_pixtext(vbox12, GTK_CLIST(clist28), row, 0, (gchar **)ssubnet_xpm, buf);
			gtk_clist_set_row_data(GTK_CLIST(clist28), row, sn);
			row++;
		}
	}

/*
	for (ln=main->session->data->devices.get_head(); ln!=NULL; ln=ln->next)
	{
		r = (Device*) ln->item;
		r->match(search_string);
		if (r->find!='0')
		{
			sprintf(buf, "%s", r->name);
			data[0] = strdup("");
			gtk_clist_append(GTK_CLIST(clist28), data);
			delete data[0];
			clist_pixtext(vbox12, GTK_CLIST(clist28), row, 0, (gchar **)srouter_xpm, buf);
			gtk_clist_set_row_data(GTK_CLIST(clist28), row, r);
			row++;
		}
	}
*/

/*
	for (ln3=main->files->objects->machines.get_head(); ln3!=NULL; ln3=ln3->next)
	{
		m = (Machine*) ln3->item;
		m->match(txt);
		if (m->find > 0)
		{
			data[0] = strdup("Machine");
			sprint_mac(m->mac, buf);
			m->ip.sprint(buf2);
			if (strcmp(m->name, "")!=0)
			{
				data[1] = strdup(m->name);
			}else
			if ((strcmp(buf2, "")!=0) && (strcmp(buf2, "0.0.0.0")!=0))
			{
				data[1] = strdup(buf2);
			}else
				data[1] = strdup(buf);
			gtk_clist_append(GTK_CLIST(clist15), data);
			delete data[0]; delete data[1];
			gtk_clist_set_row_data(GTK_CLIST(clist15), row, m);
			row++;
		}
	}
*/
	gtk_clist_thaw(GTK_CLIST(clist28));
}

void SearchSideBar::in_match(char *txt, char *lbl, int y)
{
//	int i=0;

/*
	if (lower_contains(txt, search_string))
	{
		gdk_gc_set_foreground(gc, &main->red);
		i=1;
	}
	gdk_draw_text(drawingarea10->window, main->font12m, gc, 152, y,
		txt, strlen(txt));
	if (i==1)
		gdk_gc_set_foreground(gc, &main->black);
	gdk_draw_text(drawingarea10->window, main->font12b, gc, 2, y,
			lbl, strlen(lbl));
*/
}

void SearchSideBar::quicksearch(char *str)
{
	Link *ln, *ln2, *ln3, *ln4;
	Device *d;
	Subnet *s;
	Interface *in;
	Machine *m;

	printf("QUICK SEARCH %s\n", str);

	if (strlen(str)==0) return;

	for (ln=main->session->data->devices.get_head(); ln!=NULL; ln=ln->next)
	{
		d = (Device*) ln->item;
		d->shown = (d->match(str)>0)?TRUE:FALSE;
		for (ln2=d->interfaces.get_head(); ln2!=NULL; ln2=ln2->next)
		{
			in = (Interface*) ln2->item;
			in->network->shown = (in->match(str)>0)?TRUE:FALSE;
			if (in->network->shown==TRUE) d->shown = TRUE;
			for (ln3=in->machines.get_head(); ln3!=NULL; ln3=ln3->next)
			{
				m = (Machine*) ln3->item;
				m->shown = (m->match(str)>0)?TRUE:FALSE;
				if (m->shown==TRUE) { in->network->shown = TRUE; d->shown = TRUE; }
			}
		}
	}

	// also need to check subnets
	for (ln4=main->session->data->subnets.get_head(); ln4!=NULL; ln4=ln4->next)
	{
		s = (Subnet*) ln4->item;
		if (s->match(str)>0)
		{
			for (ln=main->session->data->devices.get_head(); ln!=NULL; ln=ln->next)
			{
				d = (Device*) ln->item;
				if (d->matchsubnet(s)>0) d->shown = TRUE;
				for (ln2=d->interfaces.get_head(); ln2!=NULL; ln2=ln2->next)
				{
					in = (Interface*) ln2->item;
					if (in->matchsubnet(s)>0) in->network->shown = TRUE;
					if (in->network->shown == TRUE) d->shown = TRUE;
					for (ln3=in->machines.get_head(); ln3!=NULL; ln3=ln3->next)
					{
						m = (Machine*) ln3->item;
						if (m->matchsubnet(s)>0) m->shown = TRUE;
						if (m->shown==TRUE) { in->network->shown = TRUE; d->shown = TRUE; }
					}
				}
			}
		}
	}
}

