# Note that this is NOT a relocatable package
%define ver      0.3.1
%define rel      1
%define prefix   /usr
%define sysconfdir	/etc

Summary:   A network mapping and monitoring program.
Name:      nomad
Version:   %ver
Release:   %rel
Copyright: GNU General Public License
Group:     Applications/Internet
Vendor:    Newcastle University
Source:    nomad-%{PACKAGE_VERSION}.tar.gz
URL:       http://netmon.ncl.ac.uk/
BuildRoot: /tmp/nomad-%{PACKAGE_VERSION}-root
Packager:  Paul Coates <Paul.Coates@ncl.ac.uk>
Autoreq: 0
BuildRequires:	glib-devel
BuildRequires:	gtk+-devel >= 1.2.9
BuildRequires:	libxml-devel >= 1.8.14
BuildRequires:	gnome-libs-devel >= 1.2.11
BuildRequires:	GConf-devel >= 1.0.4
BuildRequires:	gdk-pixbuf-devel >= 0.10.1
BuildRequires:	libglade-devel >= 0.13
Requires:	      glib
Requires:       fping >= 2.2b1
Requires:       ucd-snmp >= 4.0.1
Requires:       ucd-snmp-utils >= 4.0.1
Requires:       gtk+ >= 1.2.9
Requires:       libxml >= 1.8.14
Requires:       gnome-libs >= 1.2.11
Requires:       GConf >= 1.0.4
Requires:       gdk-pixbuf >= 0.10.1
Requires: 	    libglade >= 0.13

%description
Nomad is a network mapping program designed to automatically discover a local network, using SNMP to identify network devices and work out how they are physically connected together. The network is then presented as a topology diagram with simple integrated monitoring.

%prep
%setup

%build
if [ ! -f configure ]; then
	CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --prefix=%{prefix} \
		--with-gnome --without-debug --sysconfdir=%{sysconfdir} \
		--disable-install-schemas
else
	CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} \
		--with-gnome --without-debug --sysconfdir=%{sysconfdir} \
		--disable-install-schemas
fi

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

%install
rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT%{sysconfdir} install

%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(0555, bin, bin, 755)

%doc AUTHORS COPYING ChangeLog NEWS README INSTALL

%{_bindir}/nomad
%{_bindir}/nomad-client
%{_bindir}/nomad-server
%{_bindir}/nomad-alive
%{_bindir}/nomad-topology
%{_bindir}/nomad-traceroute
%{_bindir}/nomad-traffic
%{_bindir}/nomad-config-tool

%defattr (0444, bin, bin,755)
%config %{_sysconfdir}/gconf/schemas/nomad.schemas
%{_datadir}/gnome/apps/Internet/*.desktop
%{_datadir}/nomad
%{_datadir}/pixmaps/*

%post
%{_bindir}/nomad-config-tool

