/* main.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef MAIN_H
#define MAIN_H 1

#include <gconf/gconf-client.h>
#include "process.h"
#include "list.h"

class Main
{
	public:
		Main(int argc, char *argv[]);
		~Main();

		void run();
		void tasks_from_devices(List *lst, char *str);
		void process_tasks(List *lst);
		void check_incoming_task(List *lst, Process *p);
		void status();
		void quit();

		GConfClient *client;
		char datadir[256];
		char session[256];
		List processes;
		List stat_tasks;
		time_t stat_tm;
};

#endif

