#include <stdlib.h>
#include <string.h>
#include "viewitem.h"

ViewItem::ViewItem()
{
	empty();
}

ViewItem::~ViewItem()
{
}

void ViewItem::empty()
{
	ip.empty();
	mac.empty();
	iface = 0;
	x = rand()%480;
	y = rand()%320;
	shown = TRUE;
	group3 = device_group_bunch;
	group = network_auto;
	position = network_position_manual;
	group2 = network_group_none;
}

void ViewItem::savexml(xmlNodePtr xmlnode, VisualType type)
{
	xmlNodePtr newxml;
	char buf[64];

	if (type==visual_device) strcpy(buf, "Device"); else
	if (type==visual_network) strcpy(buf, "Network"); else
	if (type==visual_machine) strcpy(buf, "Machine"); else
		return;

	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)buf, NULL);
	if (type==visual_network)
	{
		xmlSetProp(newxml, (xmlChar*)"ip", (xmlChar*)ip.getstring());
		sprintf(buf, "%d", iface);
		xmlSetProp(newxml, (xmlChar*)"interface", (xmlChar*)buf);
		if (group==network_vbus) strcpy(buf, "vbus"); else
		if (group==network_hbus) strcpy(buf, "hbus"); else
		if (group==network_p2p) strcpy(buf, "p2p"); else
		if (group==network_ring) strcpy(buf, "ring"); else
		if (group==network_cloud) strcpy(buf, "cloud"); else
			strcpy(buf, "automatic");
		xmlSetProp(newxml, (xmlChar*)"group", (xmlChar*)buf);
		if (position==network_position_manual) strcpy(buf, "manual"); else
			strcpy(buf, "automatic");
		xmlSetProp(newxml, (xmlChar*)"position", (xmlChar*)buf);
		if (group2==network_group_bus) strcpy(buf, "bus"); else
		if (group2==network_group_star) strcpy(buf, "star"); else
		if (group2==network_group_bunch) strcpy(buf, "bunch"); else
			strcpy(buf, "none");
		xmlSetProp(newxml, (xmlChar*)"group2", (xmlChar*)buf);
	}
	if (type==visual_device)
	{
		xmlSetProp(newxml, (xmlChar*)"ip", (xmlChar*)ip.getstring());
		if (group3==device_group_bunch) strcpy(buf, "bunch"); else
		if (group3==device_group_star) strcpy(buf, "star"); else
			strcpy(buf, "none");
		xmlSetProp(newxml, (xmlChar*)"group3", (xmlChar*)buf);
	}
	if (type==visual_machine)
	{
		xmlSetProp(newxml, (xmlChar*)"mac", (xmlChar*)mac.getstring());		
	}
	sprintf(buf, "%d", x);
	xmlSetProp(newxml, (xmlChar*)"x", (xmlChar*)buf);
	sprintf(buf, "%d", y);
	xmlSetProp(newxml, (xmlChar*)"y", (xmlChar*)buf);
	sprintf(buf, "%s", (shown==TRUE)?"yes":"no");
	xmlSetProp(newxml, (xmlChar*)"show", (xmlChar*)buf);
}

void ViewItem::loadxml(xmlNodePtr xmlnode)
{
	xmlChar *buf;

	if (xmlnode->name && ((strcmp((char*)xmlnode->name, "Device")==0) ||
												(strcmp((char*)xmlnode->name, "Network")==0) ||
												(strcmp((char*)xmlnode->name, "Machine")==0)))
	{
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"ip");
		if (buf!=NULL) { ip.setstring((char*)buf); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"mac");
		if (buf!=NULL) { mac.setstring((char*)buf); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"x");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &x); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"y");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &y); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"interface");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &iface); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"show");
		if (buf!=NULL)
		{ shown = (strcmp((char*)buf, "yes")==0)?TRUE:FALSE; free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"group");
		if (buf!=NULL)
		{
			if (strcmp((char*)buf, "vbus")==0) group = network_vbus; else
			if (strcmp((char*)buf, "hbus")==0) group = network_hbus; else
			if (strcmp((char*)buf, "p2p")==0) group = network_p2p; else
			if (strcmp((char*)buf, "ring")==0) group = network_ring; else
			if (strcmp((char*)buf, "cloud")==0) group = network_cloud; else
				group = network_auto;
			free(buf);
		}
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"position");
		if (buf!=NULL)
		{
			if (strcmp((char*)buf, "manual")==0)
				position = network_position_manual;
			else
				position = network_position_auto;
			free(buf);
		}
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"group2");
		if (buf!=NULL)
		{
			if (strcmp((char*)buf, "bus")==0) group2 = network_group_bus; else
			if (strcmp((char*)buf, "star")==0) group2 = network_group_star; else
			if (strcmp((char*)buf, "bunch")==0) group2 = network_group_bunch; else
				group2 = network_group_none;
			free(buf);
		}
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"group3");
		if (buf!=NULL)
		{
			if (strcmp((char*)buf, "bunch")==0) group3 = device_group_bunch; else
			if (strcmp((char*)buf, "star")==0) group3 = device_group_star; else
				group3 = device_group_star;
			free(buf);
		}
	}
}

